__device__ inline bool check_exact_one(char* mtx, int S, int U) {
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
            if (mtx[4*i + j] == 0 && i == S && j == U)
                return false;
            if (mtx[4*i + j] == 1 && i != S && j != U)
                return false;
            if (mtx[4*i + j] == 1 && i == S && j != U)
                return false;
            if (mtx[4*i + j] == 1 && i != S && j == U)
                return false;
        }
    }
    return true;
}

__global__ void exact_one(char* egysulyi_mtx, int len, bool* ok_arr, int S, int U) {
    int pos = blockDim.x * blockIdx.x + threadIdx.x;
    if (pos >= len)
        return;
    ok_arr[pos] = check_exact_one(egysulyi_mtx + pos*16, S, U);
}

__device__ inline bool check_search(char* mtx, int S, int U) {
    if (mtx[4*S + U] == 1)
        return false;
    return true;
}

__global__ void search(char* egysulyi_mtx, int len, bool* ok_arr, int S, int U) {
    int pos = blockDim.x * blockIdx.x + threadIdx.x;
    if (pos >= len)
        return;
    ok_arr[pos] = check_search(egysulyi_mtx + pos*16, S, U);
}